﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.IO;

namespace Illumination
{
    /// <summary>
    /// MainWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class MainWindow : Window
    {
        double[,] N;
        double[] aR, D, Dr, X, U, Y, V, Z, Ox, Oy;
        double[]  X0, Y0;
        int NUMB, NWL;

        double[,] IXY, IUV, IUV_P;
        int[] M;
        double[] P, P2;
        double DX, DR;//DX=照度位置刻み(mm)、DR=照度角度刻み(rad)


        int Nixy;//表示領域分割数


        int	SSf;//絞りフラグ
        int	Ns,Nh;
        int	RNs,RNh;
        double	R0,H;
        double	fai1,fai2;
        int	NJr;
        double	TRN;//トータル光線数
        double	TTN,RTN;//透過光線
        int	VPx,VPy;//評価点
        double	A,B,C,tanU0,tanV0,XB,YB;
        double	Sta0,Sta1;
        double	Hx,Hy,Hz,L0x,L0y,L0z,At,Bt,Ct,Kh;
        double	DHx,DHy,DHz,ADH,L1x,L1y,L1z;
        double	sinS0,sinS1,cosS0,cosS1;
        double[] RU0, RV0;


        public MainWindow()
        {
            InitializeComponent();
            myControl.UC = this;
            myControl.SetUC();
        }

        private void Button1_Click(object sender, RoutedEventArgs e)
        {
            int i, j,k;

            Nixy = 40;
            IXY = new double[Nixy + 1, Nixy + 1];
            IUV = new double[Nixy + 1, Nixy + 1];
            IUV_P = new double[Nixy + 1, Nixy + 1];


            


            myControl.SetUC();

            if (myControl.BEdit)
            {
                System.Windows.MessageBox.Show("dataGridView1が編集中です！！");
            }
            else
            {

                IN_FM();
                

                IN_RAY();
                TRN = 0;

               
                D = new double[NUMB + 1];
                X = new double[NUMB + 1];
                Y = new double[NUMB + 1];
                Z = new double[NUMB + 1];
                X0 = new double[NUMB + 1];
                Y0 = new double[NUMB + 1];




                for (i = 0; i <= Nixy; i++)
                {
                    for (j = 0; j <= Nixy; j++)
                    {
                        IXY[i,j] = 0;
                        IUV[i,j] = 0;
                        IUV_P[i,j] = 0;
                    }
                }
                //err=fopen_s(&f1,"OUT_M.xls","w");
                for (k = 0; k < Nh; k++)
                {
                    D[0] = Dr[0] - H / 2 + H * k / Nh;//レンズ面絶対位置設定
                    for (i = 1; i <= NUMB; i++)//レンズ面絶対位置設定
                    {
                        D[i] = Dr[i] + D[i - 1];
                    }

                    for (j = 0; j < Ns; j++)
                    {
                        X[0] = X0[0] + R0 * Math.Cos(2 * Math.PI * j / Ns);//入射X方向位置(mm)
                        Y[0] = Y0[0] + R0 * Math.Sin(2 * Math.PI * j / Ns);//入射Y方向位置(mm)
                        out2_1();

                    }

                }
                TTN = 0;
                for (i = 0; i <= Nixy; i++)
                {
                    for (j = 0; j <= Nixy; j++)
                    {
                        TTN = TTN + IXY[i,j];
                    }
                }

                RTN = TTN / TRN;

                SetDataGrid();
            }
        }

        void SetDataGrid()
        {

            var win = new Window1();

            win.myControl2.dataGridView1.ColumnCount = Nixy + 2;
            win.myControl2.dataGridView1.RowCount = 3 * (Nixy + 3) + 5;
            win.myControl2.dataGridView1.Rows[0].Cells[0].Value = "領域分割数";
            win.myControl2.dataGridView1.Rows[0].Cells[1].Value = Convert.ToString(Nixy);
            win.myControl2.dataGridView1.Rows[1].Cells[0].Value = "トータル光線数";
            win.myControl2.dataGridView1.Rows[1].Cells[1].Value = Convert.ToString(TRN);
            win.myControl2.dataGridView1.Rows[2].Cells[0].Value = "透過光線数";
            win.myControl2.dataGridView1.Rows[2].Cells[1].Value = Convert.ToString(TTN);
            win.myControl2.dataGridView1.Rows[3].Cells[0].Value = "透過光線比";
            win.myControl2.dataGridView1.Rows[3].Cells[1].Value = Convert.ToString(RTN);

            int i,j;

            win.myControl2.dataGridView1.Rows[5].Cells[0].Value = "照度分布";
            win.myControl2.dataGridView1.Rows[5 + Nixy + 3].Cells[0].Value = "平均角度分布";
            win.myControl2.dataGridView1.Rows[5 + (Nixy + 3)*2].Cells[0].Value = "評価点角度";
            for (j = 0; j <= Nixy; j++)
            {
                for (i = 0; i <= Nixy; i++)
                {
                    win.myControl2.dataGridView1.Rows[6 + j].Cells[i].Value = Convert.ToString(IXY[j,i]);
                    win.myControl2.dataGridView1.Rows[6  +j+Nixy + 3].Cells[i].Value = Convert.ToString(IUV[j, i]);
                    win.myControl2.dataGridView1.Rows[6  +j + (Nixy + 3)*2].Cells[i].Value = Convert.ToString(IUV_P[j, i]);
                }
            }

            win.Show();

        }

   


        void IN_FM()
        {
            NUMB = Convert.ToInt32(TextBox1.Text);//Lens面数
            NWL = Convert.ToInt32(TextBox2.Text);//波長数
            RNs = Convert.ToInt32(TextBox3.Text);//光線円周方向の分割数
            RNh = Convert.ToInt32(TextBox4.Text);//光線半径方向の分割数
            Ns = Convert.ToInt32(TextBox5.Text);//アーク円周方向の分割数
            Nh = Convert.ToInt32(TextBox6.Text);//アーク高さ方向の分割数
            fai1 = Convert.ToDouble(TextBox7.Text);//光線スタート角度
            fai2 = Convert.ToDouble(TextBox8.Text);//光線終了角度
            R0 = Convert.ToDouble(TextBox9.Text);//アーク半径
            H = Convert.ToDouble(TextBox10.Text);//アーク高さ
            DX = Convert.ToDouble(TextBox11.Text);//照度位置刻み
            DR = Convert.ToDouble(TextBox12.Text);//照度角度刻み
            VPx = Convert.ToInt32(TextBox13.Text);//評価点X
            VPy = Convert.ToInt32(TextBox14.Text);//評価点Y

            aR = new double[NUMB + 1];
            Dr = new double[NUMB + 1];
            Ox = new double[NUMB + 1];
            Oy = new double[NUMB + 1];
            M = new int[NUMB + 1];
            P = new double[NUMB + 1];
            P2 = new double[NUMB + 1];
            N = new double[NWL + 1, NUMB + 1];

            

            int i,j;
            for (i = 0; i < NUMB; i++)
            {
                aR[i] = Convert.ToDouble(myControl.dataGridView1.Rows[2 + i].Cells[1].Value);
                Dr[i] = Convert.ToDouble(myControl.dataGridView1.Rows[2 + i].Cells[2].Value);
                Ox[i] = Convert.ToDouble(myControl.dataGridView1.Rows[2 + i].Cells[3].Value);
                Oy[i] = Convert.ToDouble(myControl.dataGridView1.Rows[2 + i].Cells[4].Value);
                M[i] = Convert.ToInt32(myControl.dataGridView1.Rows[2 + i].Cells[5].Value);
                if ((String)myControl.dataGridView1.Rows[2 + i].Cells[6].Value != "")
                { P[i] = Convert.ToDouble(myControl.dataGridView1.Rows[2 + i].Cells[6].Value); }
                if ((String)myControl.dataGridView1.Rows[2 + i].Cells[7].Value != "")
                { P2[i] = Convert.ToDouble(myControl.dataGridView1.Rows[2 + i].Cells[7].Value); }

                for (j = 1; j <= NWL; j++)
                {
                    N[j,i] = Convert.ToDouble(myControl.dataGridView1.Rows[2 + i].Cells[7+j].Value);
                }
            }
        }

        private void ComboBox1_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (myControl != null)
            {
                // myControl.M1 = ComboBox1.SelectedIndex;
            }
        }

        private void MenuItem2_Click(object sender, RoutedEventArgs e)
        {
            if (myControl.BEdit)
            {
                System.Windows.MessageBox.Show("dataGridView1が編集中です！！");
            }
            else
            {
                if (myControl.saveFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    using (StreamWriter outfile = new StreamWriter(myControl.saveFileDialog1.FileName))
                    {
                        outfile.Write(Out_Text());
                    }
                }
            }
        }

        String Out_Text()
        {
            int i; int j;
            int N = Convert.ToInt32(TextBox1.Text);

            String OutText = "Illumination\r\n";
            OutText = OutText + "項目\t記号\t値\t単位\r\n";
            OutText = OutText + "Lens面数\tNUMB\t" + TextBox1.Text + "\t整数\r\n";
            OutText = OutText + "波長数\tNWL\t" + TextBox2.Text + "\t整数\r\n";
            OutText = OutText + "光線円周方向の分割数\tRNs\t" + TextBox3.Text + "\t整数\r\n";
            OutText = OutText + "光線半径方向の分割数\tRNh\t" + TextBox4.Text + "\t整数\r\n";
            OutText = OutText + "アーク円周方向の分割数\tNs\t" + TextBox5.Text + "\t整数\r\n";
            OutText = OutText + "アーク高さ方向の分割数\tNh\t" + TextBox6.Text + "\t整数\r\n";
            OutText = OutText + "光線スタート角度\tfai1\t" + TextBox7.Text + "\trad\r\n";
            OutText = OutText + "光線終了角度\tfai2\t" + TextBox8.Text + "\trad\r\n";
            OutText = OutText + "アーク半径\tR0\t" + TextBox9.Text + "\tmm\r\n";
            OutText = OutText + "アーク高さ\tH\t" + TextBox10.Text + "\tmm\r\n";
            OutText = OutText + "照度位置刻み\tDX\t" + TextBox11.Text + "\tmm\r\n";
            OutText = OutText + "照度角度刻み\tDR\t" + TextBox12.Text + "\trad\r\n";
            OutText = OutText + "評価点X\tVPx\t" + TextBox13.Text + "\t整数\r\n";
            OutText = OutText + "評価点Y\tVPy\t" + TextBox14.Text + "\t整数\r\n";

            OutText = OutText + "光学系基本定数表\r\n";


            for (i = 0; i <= 10; i++) { OutText = OutText + myControl.dataGridView1.Columns[i].HeaderText + "\t"; }
            OutText = OutText + "\r\n";

            for (i = 0; i < N + 2; i++)
            {
                for (j = 0; j <= 10; j++)
                {
                    OutText = OutText + myControl.dataGridView1.Rows[i].Cells[j].Value + "\t";
                }
                OutText = OutText + "\r\n";
            }


            return OutText;
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            this.WindowState = WindowState.Minimized;
            this.WindowState = WindowState.Normal;
        }

       

        private void MenuItem3_Click(object sender, RoutedEventArgs e)
        {
            int i; int j;
            String[,] HData = new String[17, 6];

            if (myControl.BEdit)
            {
                System.Windows.MessageBox.Show("dataGridView1が編集中です！！");
            }
            else
            {

                if (myControl.openFileDialog1.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                {
                    using (Microsoft.VisualBasic.FileIO.TextFieldParser MyReader = new Microsoft.VisualBasic.FileIO.TextFieldParser(myControl.openFileDialog1.FileName))
                    {
                        MyReader.TextFieldType = Microsoft.VisualBasic.FileIO.FieldType.Delimited;
                        MyReader.SetDelimiters("\t");
                        String[] currentRow;
                        for (i = 0; i < 17; i++)
                        {
                            currentRow = MyReader.ReadFields();
                            if (currentRow != null)
                            {
                                j = 0;
                                foreach (String currentField in currentRow)
                                {
                                    HData[i, j] = currentField;
                                    if (j < 5) { j = j + 1; }
                                }
                            }
                        }

                        if (HData[0, 0] == "Illumination")
                        {
                            int N = Convert.ToInt32(HData[2, 2]);

                            String[,] RCData = new String[N + 4, 11];
                            for (i = 0; i < N + 3; i++)
                            {
                                currentRow = MyReader.ReadFields();
                                j = 0;
                                foreach (String currentField in currentRow)
                                {
                                    RCData[i, j] = currentField;
                                    if (j < 11) { j = j + 1; }
                                }
                            }

                            TextBox1.Text = HData[2, 2];
                            TextBox2.Text = HData[3, 2];
                            TextBox3.Text = HData[4, 2];
                            TextBox4.Text = HData[5, 2];
                            TextBox5.Text = HData[6, 2];
                            TextBox6.Text = HData[7, 2];
                            TextBox7.Text = HData[8, 2];
                            TextBox8.Text = HData[9, 2];
                            TextBox9.Text = HData[10, 2];
                            TextBox10.Text = HData[11, 2];

                            TextBox11.Text = HData[12, 2];
                            TextBox12.Text = HData[13, 2];
                            TextBox13.Text = HData[14, 2];
                            TextBox14.Text = HData[15, 2];


                            myControl.SetUC();



                            for (i = 0; i < N; i++)
                            {
                                for (j = 0; j < 11; j++)
                                {
                                    myControl.dataGridView1.Rows[2 + i].Cells[j].Value = RCData[i + 3, j];
                                }
                            }

                        }
                        else
                        {
                            System.Windows.MessageBox.Show("ファイル形式が異なります！！");
                        }
                    }
                }
            }
        }

        void IN_RAY()
        {
            int j, k, kk;
            double Rx, Rs;
            int CNs;
            double CosRx, Mx, My;

            U = new double[NUMB + 1];
            V = new double[NUMB + 1];
            

            kk = 0;
            for (j = 0; j <= RNh; j++)
            {
                Rx = fai1 + (fai2 - fai1) * j / RNh;
                //CosRx = Math.Cos(Rx);


                CNs = (int)Math.Floor(Math.Abs(Math.Sin(Rx) * RNs) + 0.5);

                for (k = 0; k < CNs; k++)
                {
                    kk = kk + 1;
                }
            }

            int TK = kk;

            RU0 = new double[TK+2];
            RV0 = new double[TK+2];


            kk = 0;

            //err = fopen_s(&f2, "OUT_MI.xls", "w");
            //fputs("X[NUMB]\tY[NUMB]\tZ[NUMB]\tU[NUMB]\tV[NUMB]\n", f2);

            for (j = 0; j <= RNh; j++)
            {
                Rx = fai1 + (fai2 - fai1) * j / RNh;
                CosRx =Math.Cos(Rx);


                CNs = (int)Math.Floor(Math.Abs(Math.Sin(Rx) * RNs) + 0.5);

                for (k = 0; k < CNs; k++)
                {
                    Rs = 2 * Math.PI * k / CNs;
                    Mx = Math.Sin(Rx) * Math.Cos(Rs);
                    My = Math.Sin(Rx) * Math.Sin(Rs);

                    if (CosRx > 0)
                    {
                        //double The = Mx / CosRx;
                        U[0] = Math.Atan(Mx / CosRx);
                        V[0] = Math.Atan(My/CosRx);
                    }
                    else
                    {
                        if (Mx > 0)
                        {
                            U[0] = Math.PI + Math.Atan(Mx / CosRx);
                        }
                        else
                        {
                            U[0] = -Math.PI + Math.Atan(Mx / CosRx);
                        }
                        if (My > 0)
                        {
                            V[0] = Math.PI + Math.Atan(My / CosRx);
                        }
                        else
                        {
                            V[0] = -Math.PI + Math.Atan(My / CosRx);
                        }

                    }
                    //sprintf_s(s1, "%f\t%f\t%f\t%f\t%f\n", X[0], Y[0], Z[0], U[0], V[0]);
                    //fputs(s1, f2);
                    kk = kk + 1;
                    if (kk > 10000) { kk = 10000; }
                    RU0[kk] = U[0];
                    RV0[kk] = V[0];
                }
            }

            NJr = kk;
        }


        void out2_1()
        {
            //FILE* f2; errno_t err;
            //char	s1[256];

            int i, j, ii, Nr;
            int ix, iy, iu, iv;
            double Lx, Ly, Hx, Hy, Cs;



            //f2=fopen("C:\\Program Files\\VBA_C_OPTICS\\OUT_MR.XLS","w");
            //err = fopen_s(&f2, "OUT_MR.xls", "w");


            Z[0] = 0;
            for (ii = 1; ii <= NWL; ii++)
            {
                Nr = 0;
                for (i = 0; i <= NUMB; i++)
                {
                    N[0,i] = N[ii,i];//屈折率N1を設定
                }
                for (j = 1; j <= NJr; j++)
                {
                    U[0] = RU0[j];
                    V[0] = RV0[j];

                    Lx = Math.Tan(U[0]) / Math.Sqrt(1 + Math.Tan(U[0]) * Math.Tan(U[0]) + Math.Tan(V[0]) * Math.Tan(V[0]));
                    Ly = Math.Tan(V[0]) / Math.Sqrt(1 + Math.Tan(U[0]) * Math.Tan(U[0]) + Math.Tan(V[0]) * Math.Tan(V[0]));
                    Hx = X[0] / Math.Sqrt(X[0] * X[0] + Y[0] * Y[0]);
                    Hy = Y[0] / Math.Sqrt(X[0] * X[0] + Y[0] * Y[0]);
                    //Cs = Lx * Hx + Ly * Hy;
                    Cs = 1;

                    if (Cs >= 0)
                    {
                        Nr = Nr + 1;
                        CAL_RAY();

                        ix = (int)Math.Floor(X[NUMB - 1] / DX + Nixy/2 + 0.5); if (ix < 0) SSf = 0; if (ix > Nixy) SSf = 0;
                        iy = (int)Math.Floor(Y[NUMB - 1] / DX + Nixy / 2 + 0.5); if (iy < 0) SSf = 0; if (iy > Nixy) SSf = 0;
                        iu = (int)Math.Floor(U[NUMB - 1] / DR + Nixy / 2 + 0.5); if (iu < 0) SSf = 0; if (iu > Nixy) SSf = 0;
                        iv = (int)Math.Floor(V[NUMB - 1] / DR + Nixy / 2 + 0.5); if (iv < 0) SSf = 0; if (iv > Nixy) SSf = 0;
                        if (SSf == 1)
                        {
                            IXY[ix,iy] = IXY[ix,iy] + Cs;
                            IUV[iu,iv] = IUV[iu,iv] + Cs;
                            if (ix == VPx && iy == VPy)
                            {
                                IUV_P[iu,iv] = IUV_P[iu,iv] + Cs;
                            }
                        }
                        TRN = TRN + Cs;


                    }

                }
            }

            //fclose(f2);
        }

        void CAL_RAY()
        {
            int		i;
	
            SSf=1;
            for (i = 0; i < NUMB - 1; i++)
            {
                switch (M[i + 1])
                {
                    case 1:
                        CAL_RAY_1(i);//標準レンズ
                        break;
                    case 2:
                        CAL_RAY_2(i);//球面ミラー
                        break;
                    case 3:
                        CAL_RAY_3(i);//放物面ミラー
                        break;
                    case 4:
                        CAL_RAY_4(i);//シリンドカルレンズ
                        break;
                    case 5:
                        CAL_RAY_5(i);//シリンドカルレンズフライアイ
                        break;
                    case 6:
                        CAL_RAY_6(i);//絞り
                        break;
                    case 7:
                        CAL_RAY_7(i);//フライアイ
                        break;
                    case 8:
                        CAL_RAY_8(i);//楕円面ミラー
                        break;
                    case 9:
                        CAL_RAY_9(i);//傾斜凹面ミラー
                        break;
                    default:
                        CAL_RAY_1(i);//標準レンズ
                        break;
                }
    
            }


        }

        //球面レンズ
        void CAL_RAY_1(int i)
        {
            tanU0 =Math.Tan(U[i]);
            tanV0 = Math.Tan(V[i]);
            XB = X[i] + tanU0 * Z[i] - Ox[i + 1];
            YB = Y[i] + tanV0 * Z[i] - Oy[i + 1];
            if (aR[i + 1] == 0)
            {//半径R=∞の時は平面となる。
                Z[i + 1] = D[i];
            }
            else
            {//半径R≠∞の時
                A = 1 + tanU0 * tanU0 + tanV0 * tanV0;
                B = -2 * (D[i] + 1 / aR[i + 1] + tanU0 * XB + tanV0 * YB);
                C = D[i] * D[i] + 2 * D[i] / aR[i + 1] + XB * XB + YB * YB;

                if (aR[i + 1] > 0) Z[i + 1] = (-B - Math.Sqrt(B * B - 4 * A * C)) / (2 * A);
                if (aR[i + 1] < 0) Z[i + 1] = (-B + Math.Sqrt(B * B - 4 * A * C)) / (2 * A);
            }

            X[i + 1] = X[i] - tanU0 * (Z[i + 1] - Z[i]);
            Y[i + 1] = Y[i] - tanV0 * (Z[i + 1] - Z[i]);


            Hx = (-X[i + 1] + Ox[i + 1]) * aR[i + 1];//X方向法線ベクトル
            Hy = (-Y[i + 1] + Oy[i + 1]) * aR[i + 1];//Y方向法線ベクトル
            if (aR[i + 1] == 0)
            {//半径R=∞の時
                Hz = 1;//Z方向法線ベクトル
            }
            else
            {//半径R≠∞の時
                Hz = (-Z[i + 1] + D[i] + 1 / aR[i + 1]) * aR[i + 1];//Z方向法線ベクトル
            }
            L0z = 1 / Math.Sqrt(1 + tanU0 * tanU0 + tanV0 * tanV0);//Z方向入射ベクトル
            L0x = -tanU0 * L0z;//X方向入射ベクトル
            L0y = -tanV0 * L0z;//Y方向入射ベクトル

            Sta0 = Math.Acos(Math.Abs(Hx * L0x + Hy * L0y + Hz * L0z));//入射角度
            sinS0 = Math.Sin(Sta0);
            cosS0 = Math.Cos(Sta0);

            if (N[0,i] <= 0)
            {
                Sta1 = Math.Asin(sinS0 * (-N[0,i]) / N[0,i + 1]);//出射角度
            }
            else
            {
                Sta1 = Math.Asin(sinS0 * N[0,i] / N[0,i + 1]);//出射角度
            }
            sinS1 = Math.Sin(Sta1);
            cosS1 = Math.Cos(Sta1);

            if (Sta0 > Sta1)
            {//屈折率大→小に変化の場合
                At = cosS1 - cosS0;
                Bt = sinS0 - sinS1;
                Ct = Math.Sqrt(At * At + Bt * Bt);

                Kh = cosS1 + sinS1 * Math.Tan((Sta0 + Sta1) / 2);
                DHx = -L0x + Kh * Hx;
                DHy = -L0y + Kh * Hy;
                DHz = -L0z + Kh * Hz;
            }
            else
            {//屈折率小→大に変化の場合
                At = cosS0 - cosS1;
                Bt = sinS1 - sinS0;
                Ct = Math.Sqrt(At * At + Bt * Bt);

                Kh = cosS0 + sinS0 * Math.Tan((Sta0 + Sta1) / 2);
                DHx = L0x - Kh * Hx;
                DHy = L0y - Kh * Hy;
                DHz = L0z - Kh * Hz;
            }


            ADH = Math.Sqrt(DHx * DHx + DHy * DHy + DHz * DHz);//変化量の絶対値

            if (ADH == 0)
            {//変化量ゼロの場合
                L1x = L0x;
                L1y = L0y;
                L1z = L0z;
            }
            else
            {//屈折した場合
                L1x = L0x + Ct * DHx / ADH;
                L1y = L0y + Ct * DHy / ADH;
                L1z = L0z + Ct * DHz / ADH;
            }
            U[i + 1] = -Math.Atan(L1x / L1z);//X方向出射角度
            V[i + 1] = -Math.Atan(L1y / L1z);//Y方向出射角度
        }

        //球面ミラー
        void CAL_RAY_2(int i)
        {
            tanU0 =Math.Tan(U[i]);
            tanV0 = Math.Tan(V[i]);
            XB = X[i] + tanU0 * Z[i] - Ox[i + 1];
            YB = Y[i] + tanV0 * Z[i] - Oy[i + 1];
            if (aR[i + 1] == 0)
            {//半径R=∞の時は平面となる。
                Z[i + 1] = D[i];
            }
            else
            {//半径R≠∞の時
                A = 1 + tanU0 * tanU0 + tanV0 * tanV0;
                B = -2 * (D[i] + 1 / aR[i + 1] + tanU0 * XB + tanV0 * YB);
                C = D[i] * D[i] + 2 * D[i] / aR[i + 1] + XB * XB + YB * YB;

                if (aR[i + 1] > 0) Z[i + 1] = (-B - Math.Sqrt(B * B - 4 * A * C)) / (2 * A);
                if (aR[i + 1] < 0) Z[i + 1] = (-B + Math.Sqrt(B * B - 4 * A * C)) / (2 * A);
            }

            X[i + 1] = X[i] - tanU0 * (Z[i + 1] - Z[i]);
            Y[i + 1] = Y[i] - tanV0 * (Z[i + 1] - Z[i]);


            Hx = (-X[i + 1] + Ox[i + 1]) * aR[i + 1];//X方向法線ベクトル
            Hy = (-Y[i + 1] + Oy[i + 1]) * aR[i + 1];//Y方向法線ベクトル
            if (aR[i + 1] == 0)
            {//半径R=∞の時
                Hz = 1;//Z方向法線ベクトル
            }
            else
            {//半径R≠∞の時
                Hz = (-Z[i + 1] + D[i] + 1 / aR[i + 1]) * aR[i + 1];//Z方向法線ベクトル
            }
            L0z = 1 / Math.Sqrt(1 + tanU0 * tanU0 + tanV0 * tanV0);//Z方向入射ベクトル
            L0x = -tanU0 * L0z;//X方向入射ベクトル
            L0y = -tanV0 * L0z;//Y方向入射ベクトル

            Sta0 =Math.Acos(Math.Abs(Hx * L0x + Hy * L0y + Hz * L0z));//入射角度
            sinS0 =Math.Sin(Sta0);
            cosS0 =Math.Cos(Sta0);
            Sta1 = Sta0;//出射角度
            sinS1 = Math.Sin(Sta1);
            cosS1 = Math.Cos(Sta1);



            Ct = 2.0 * sinS0;

            Kh = cosS1;
            DHx = (Kh * Hx) - L0x;
            DHy = (Kh * Hy) - L0y;
            DHz = (Kh * Hz) - L0z;



            ADH = Math.Sqrt(DHx * DHx + DHy * DHy + DHz * DHz);//変化量の絶対値

            if (ADH == 0)
            {//変化量ゼロの場合
                L1x = L0x;
                L1y = L0y;
                L1z = L0z;
            }
            else
            {//屈折した場合
                L1x = L0x + Ct * DHx / ADH;
                L1y = L0y + Ct * DHy / ADH;
                L1z = L0z + Ct * DHz / ADH;
            }
            U[i + 1] = -Math.Atan(L1x / L1z);//X方向出射角度
            V[i + 1] = -Math.Atan(L1y / L1z);//Y方向出射角度

            Z[i + 1] = 2 * D[i] - Z[i + 1];
            U[i + 1] = -U[i + 1];
            V[i + 1] = -V[i + 1];
        }


        //放物面ミラー			
        void CAL_RAY_3(int i)
        {
            double RF;
            double F;

            F = Math.Abs(0.5 / aR[i + 1]);

            tanU0 = Math.Tan(U[i]);
            tanV0 = Math.Tan(V[i]);
            XB = X[i] + tanU0 * Z[i] - Ox[i + 1];
            YB = Y[i] + tanV0 * Z[i] - Oy[i + 1];
            if (aR[i + 1] == 0)
            {//半径R=∞の時は平面となる。		
                Z[i + 1] = D[i];
            }
            else
            {//半径R≠∞の時		
                A = tanU0 * tanU0 + tanV0 * tanV0;
                B = 2 * (2 * F - XB * tanU0 - YB * tanV0);
                C = XB * XB + YB * YB - 4 * D[i] * F;
                if (A == 0)
                {
                    Z[i + 1] = -C / B;
                }
                else
                {
                    if (Math.Abs(U[i]) < Math.PI / 2 && Math.Abs(V[i]) < Math.PI / 2)
                    {
                        Z[i + 1] = (-B + Math.Sqrt(B * B - 4 * A * C)) / (2 * A);
                    }
                    else
                    {
                        Z[i + 1] = (-B - Math.Sqrt(B * B - 4 * A * C)) / (2 * A);
                    }
                }
            }
            X[i + 1] = X[i] - tanU0 * (Z[i + 1] - Z[i]);
            Y[i + 1] = Y[i] - tanV0 * (Z[i + 1] - Z[i]);

            RF = Math.Sqrt(4 * F * F + (X[i + 1] - Ox[i + 1]) * (X[i + 1] - Ox[i + 1]) + (Y[i + 1] - Oy[i + 1]) * (Y[i + 1] - Oy[i + 1]));

            Hx = -(-X[i + 1] + Ox[i + 1]) / RF;//X方向法線ベクトル		
            Hy = -(-Y[i + 1] + Oy[i + 1]) / RF;//Y方向法線ベクトル		
            if (aR[i + 1] == 0)
            {//半径R=∞の時		
                Hz = 1;//Z方向法線ベクトル	
            }
            else
            {//半径R≠∞の時
                Hz = 2 * F / RF;//Z方向法線ベクトル
            }

            if (Math.Abs(U[i]) < Math.PI / 2 && Math.Abs(V[i]) < Math.PI / 2)
            {
                L0z = 1 / Math.Sqrt(1 + tanU0 * tanU0 + tanV0 * tanV0);//Z方向入射ベクトル
            }
            else
            {
                L0z = -1 / Math.Sqrt(1 + tanU0 * tanU0 + tanV0 * tanV0);//Z方向入射ベクトル	
            }
            L0x = -tanU0 * L0z;//X方向入射ベクトル
            L0y = -tanV0 * L0z;//Y方向入射ベクトル

            Sta0 = Math.Acos(Math.Abs(Hx * L0x + Hy * L0y + Hz * L0z));//入射角度
            sinS0 = Math.Sin(Sta0);
            cosS0 = Math.Cos(Sta0);
            Sta1 = Sta0;//出射角度
            sinS1 = Math.Sin(Sta1);
            cosS1 = Math.Cos(Sta1);



            Ct = 2.0 * sinS0;

            Kh = cosS1;
            DHx = (Kh * Hx) - L0x;
            DHy = (Kh * Hy) - L0y;
            DHz = (Kh * Hz) - L0z;

            ADH = Math.Sqrt(DHx * DHx + DHy * DHy + DHz * DHz);//変化量の絶対値

            if (ADH == 0)
            {//変化量ゼロの場合
                L1x = L0x;
                L1y = L0y;
                L1z = L0z;
            }
            else
            {//屈折した場合
                L1x = L0x + Ct * DHx / ADH;
                L1y = L0y + Ct * DHy / ADH;
                L1z = L0z + Ct * DHz / ADH;
            }
            U[i + 1] = -Math.Atan(L1x / L1z);//X方向出射角度
            V[i + 1] = -Math.Atan(L1y / L1z);//Y方向出射角度

            Z[i + 1] = 2 * D[i] - Z[i + 1];
            U[i + 1] = -U[i + 1];
            V[i + 1] = -V[i + 1];
        }


        //シリンドカルレンズ
        void CAL_RAY_4(int i)
        {
            tanU0 = Math.Tan(U[i]);
            tanV0 = Math.Tan(V[i]);
            XB = X[i] + tanU0 * Z[i] - Ox[i + 1];
            YB = Y[i] + tanV0 * Z[i] - Oy[i + 1];
            if (aR[i + 1] == 0)
            {//半径R=∞の時は平面となる。
                Z[i + 1] = D[i];
            }
            else
            {//半径R≠∞の時
                A = 1 + tanV0 * tanV0;
                B = -2 * (D[i] + 1 / aR[i + 1] + tanV0 * YB);
                C = D[i] * D[i] + 2 * D[i] / aR[i + 1] + YB * YB;

                if (aR[i + 1] > 0) Z[i + 1] = (-B - Math.Sqrt(B * B - 4 * A * C)) / (2 * A);
                if (aR[i + 1] < 0) Z[i + 1] = (-B + Math.Sqrt(B * B - 4 * A * C)) / (2 * A);
            }

            X[i + 1] = X[i] - tanU0 * (Z[i + 1] - Z[i]);
            Y[i + 1] = Y[i] - tanV0 * (Z[i + 1] - Z[i]);


            //Hx=(-X[i+1]+Ox[i+1])*aR[i+1];//X方向法線ベクトル
            Hx = 0;
            Hy = (-Y[i + 1] + Oy[i + 1]) * aR[i + 1];//Y方向法線ベクトル
            if (aR[i + 1] == 0)
            {//半径R=∞の時
                Hz = 1;//Z方向法線ベクトル
            }
            else
            {//半径R≠∞の時
                Hz = (-Z[i + 1] + D[i] + 1 / aR[i + 1]) * aR[i + 1];//Z方向法線ベクトル
            }
            L0z = 1 / Math.Sqrt(1 + tanU0 * tanU0 + tanV0 * tanV0);//Z方向入射ベクトル
            L0x = -tanU0 * L0z;//X方向入射ベクトル
            L0y = -tanV0 * L0z;//Y方向入射ベクトル

            Sta0 = Math.Acos(Math.Abs(Hx * L0x + Hy * L0y + Hz * L0z));//入射角度
            sinS0 = Math.Sin(Sta0);
            cosS0 = Math.Cos(Sta0);

            if (N[0,i] <= 0)
            {
                Sta1 =Math.Asin(sinS0 * (-N[0,i]) / N[0,i + 1]);//出射角度
            }
            else
            {
                Sta1 = Math.Asin(sinS0 * N[0,i] / N[0,i + 1]);//出射角度
            }
            sinS1 = Math.Sin(Sta1);
            cosS1 = Math.Cos(Sta1);

            if (Sta0 > Sta1)
            {//屈折率大→小に変化の場合
                At = cosS1 - cosS0;
                Bt = sinS0 - sinS1;
                Ct = Math.Sqrt(At * At + Bt * Bt);

                Kh = cosS1 + sinS1 * Math.Tan((Sta0 + Sta1) / 2);
                DHx = -L0x + Kh * Hx;
                DHy = -L0y + Kh * Hy;
                DHz = -L0z + Kh * Hz;
            }
            else
            {//屈折率小→大に変化の場合
                At = cosS0 - cosS1;
                Bt = sinS1 - sinS0;
                Ct = Math.Sqrt(At * At + Bt * Bt);

                Kh = cosS0 + sinS0 * Math.Tan((Sta0 + Sta1) / 2);
                DHx = L0x - Kh * Hx;
                DHy = L0y - Kh * Hy;
                DHz = L0z - Kh * Hz;
            }


            ADH = Math.Sqrt(DHx * DHx + DHy * DHy + DHz * DHz);//変化量の絶対値

            if (ADH == 0)
            {//変化量ゼロの場合
                L1x = L0x;
                L1y = L0y;
                L1z = L0z;
            }
            else
            {//屈折した場合
                L1x = L0x + Ct * DHx / ADH;
                L1y = L0y + Ct * DHy / ADH;
                L1z = L0z + Ct * DHz / ADH;
            }
            U[i + 1] = -Math.Atan(L1x / L1z);//X方向出射角度
            V[i + 1] = -Math.Atan(L1y / L1z);//Y方向出射角度

        }

        //シリンドカルレンズフライアイ
        void CAL_RAY_5(int i)
        {
            tanU0 = Math.Tan(U[i]);
            tanV0 = Math.Tan(V[i]);
            Z[i + 1] = D[i];

            X[i + 1] = X[i] - tanU0 * (Z[i + 1] - Z[i]);
            Y[i + 1] = Y[i] - tanV0 * (Z[i + 1] - Z[i]);

            //P[i+1]=フライアイピッチ(mm)
            Oy[i + 1] = P[i + 1] * Math.Floor(Y[i + 1] / P[i + 1] + 0.5);

            CAL_RAY_4(i);
        }

        //絞り
        void CAL_RAY_6(int i)
        {
            double AX, AY;

            tanU0 = Math.Tan(U[i]);
            tanV0 = Math.Tan(V[i]);
            Z[i + 1] = D[i];

            X[i + 1] = X[i] - tanU0 * (Z[i + 1] - Z[i]);
            Y[i + 1] = Y[i] - tanV0 * (Z[i + 1] - Z[i]);

            AX = Math.Abs(X[i + 1]);
            AY = Math.Abs(Y[i + 1]);

            //P[i]=絞り半径(mm)
            if (AX * AX + AY * AY < P[i + 1] * P[i + 1])
            {
                //SSf=1;
            }
            else
            {
                SSf = 0;
            }

            CAL_RAY_1(i);
        }

        //フライアイ
        void CAL_RAY_7(int i)
        {
            double Oxi, Oyi;

            tanU0 = Math.Tan(U[i]);
            tanV0 = Math.Tan(V[i]);
            Z[i + 1] = D[i];

            X[i + 1] = X[i] - tanU0 * (Z[i + 1] - Z[i]);
            Y[i + 1] = Y[i] - tanV0 * (Z[i + 1] - Z[i]);

            Oxi = Ox[i + 1];
            Oyi = Oy[i + 1];

            //P[i+1]=フライアイピッチ(mm)
            Ox[i + 1] = Oxi + P[i + 1] * Math.Floor((X[i + 1] - Oxi) / P[i + 1] + 0.5);
            Oy[i + 1] = Oyi + P2[i + 1] * Math.Floor((Y[i + 1] - Oyi) / P2[i + 1] + 0.5);

            CAL_RAY_1(i);
            Ox[i + 1] = Oxi;
            Oy[i + 1] = Oyi;
        }

        //楕円面ミラー(s,s")
        void CAL_RAY_8(int i)
        {
            double RF;
            double s1, s2, a, b, Hr;

            s1 = aR[i + 1];
            s2 = P[i + 1];
            a = (s1 + s2) / 2;
            b = Math.Sqrt(s1 * s2);

            tanU0 = Math.Tan(U[i]);
            tanV0 = Math.Tan(V[i]);
            XB = X[i] + tanU0 * Z[i] - Ox[i + 1];
            YB = Y[i] + tanV0 * Z[i] - Oy[i + 1];
            if (s1 == 0)
            {//半径R=∞の時は平面となる。		
                Z[i + 1] = D[i];
            }
            else
            {//半径R≠∞の時		
                A = 1 / (a * a) + (tanU0 * tanU0 + tanV0 * tanV0) / (b * b);
                B = 2 * (a - D[i]) / (a * a) - 2 * (XB * tanU0 + YB * tanV0) / (b * b);
                C = (a - D[i]) * (a - D[i]) / (a * a) + (XB * XB + YB * YB) / (b * b) - 1;

                if (Math.Abs(U[i]) < Math.PI / 2 && Math.Abs(V[i]) < Math.PI / 2)
                {
                    Z[i + 1] = (-B + Math.Sqrt(B * B - 4 * A * C)) / (2 * A);
                    X[i + 1] = X[i] - tanU0 * (Z[i + 1] - Z[i]);
                    Y[i + 1] = Y[i] - tanV0 * (Z[i + 1] - Z[i]);
                }
                else
                {
                    Z[i + 1] = (-B - Math.Sqrt(B * B - 4 * A * C)) / (2 * A);
                    X[i + 1] = -(X[i] - tanU0 * (Z[i + 1] - Z[i]));
                    Y[i + 1] = -(Y[i] - tanV0 * (Z[i + 1] - Z[i]));
                }

            }

            Hr = -b * b * (Z[i + 1] + a - D[i]) / (a * a);

            RF = Math.Sqrt(Hr * Hr + (X[i + 1] - Ox[i + 1]) * (X[i + 1] - Ox[i + 1]) + (Y[i + 1] - Oy[i + 1]) * (Y[i + 1] - Oy[i + 1]));

            Hx = -(-X[i + 1] + Ox[i + 1]) / RF;//X方向法線ベクトル		
            Hy = -(-Y[i + 1] + Oy[i + 1]) / RF;//Y方向法線ベクトル

            if (s1 == 0)
            {//半径R=∞の時		
                Hz = 1;//Z方向法線ベクトル	
            }
            else
            {//半径R≠∞の時


                if (Math.Abs(U[i]) < Math.PI / 2 && Math.Abs(V[i]) < Math.PI / 2)
                {
                    Hz = -Hr / RF;//Z方向法線ベクトル
                    L0z = 1 / Math.Sqrt(1 + tanU0 * tanU0 + tanV0 * tanV0);//Z方向入射ベクトル
                    L0x = -tanU0 * L0z;//X方向入射ベクトル
                    L0y = -tanV0 * L0z;//Y方向入射ベクトル
                }
                else
                {
                    Hz = -Hr / RF;//Z方向法線ベクトル
                    L0z = -1 / Math.Sqrt(1 + tanU0 * tanU0 + tanV0 * tanV0);//Z方向入射ベクトル
                    L0x = tanU0 * L0z;//X方向入射ベクトル
                    L0y = tanV0 * L0z;//Y方向入射ベクトル
                }
            }




            Sta0 = Math.Acos(Math.Abs(Hx * L0x + Hy * L0y + Hz * L0z));//入射角度
            sinS0 = Math.Sin(Sta0);
            cosS0 = Math.Cos(Sta0);
            Sta1 = Sta0;//出射角度
            sinS1 = Math.Sin(Sta1);
            cosS1 = Math.Cos(Sta1);



            Ct = 2.0 * sinS0;

            Kh = cosS1;

            if (Math.Abs(U[i]) < Math.PI / 2 && Math.Abs(V[i]) < Math.PI / 2)
            {
                DHx = (Kh * Hx) - L0x;
                DHy = (Kh * Hy) - L0y;
                DHz = (Kh * Hz) - L0z;
            }
            else
            {
                DHx = (Kh * Hx) - L0x;
                DHy = (Kh * Hy) - L0y;
                DHz = (Kh * Hz) - L0z;
            }

            ADH = Math.Sqrt(DHx * DHx + DHy * DHy + DHz * DHz);//変化量の絶対値

            if (ADH == 0)
            {//変化量ゼロの場合
                L1x = L0x;
                L1y = L0y;
                L1z = L0z;
            }
            else
            {//屈折した場合
                if (Math.Abs(U[i]) < Math.PI / 2 && Math.Abs(V[i]) < Math.PI / 2)
                {
                    L1x = L0x + Ct * DHx / ADH;
                    L1y = L0y + Ct * DHy / ADH;
                    L1z = L0z + Ct * DHz / ADH;
                }
                else
                {
                    L1x = -(L0x + Ct * DHx / ADH);
                    L1y = -(L0y + Ct * DHy / ADH);
                    L1z = -(L0z + Ct * DHz / ADH);
                }

            }
            U[i + 1] = -Math.Atan(L1x / L1z);//X方向出射角度
            V[i + 1] = -Math.Atan(L1y / L1z);//Y方向出射角度

            Z[i + 1] = 2 * D[i] - Z[i + 1];
            U[i + 1] = -U[i + 1];
            V[i + 1] = -V[i + 1];

        }


        //傾斜球面ミラー
        void CAL_RAY_9(int i)
        {
            double D0, DZ;

            D0 = D[i];
            Ox[i + 1] = -Math.Sin(P[i + 1]) / aR[i + 1];
            Oy[i + 1] = -Math.Sin(P2[i + 1]) / aR[i + 1];
            DZ = Math.Sqrt(1 / (aR[i + 1] * aR[i + 1]) - Ox[i + 1] * Ox[i + 1] - Oy[i + 1] * Oy[i + 1]);

            if (aR[i + 1] < 0)
            {
                D[i] = D[i] + (-1 / aR[i + 1] - DZ);
            }
            else
            {
                D[i] = D[i] - (1 / aR[i + 1] - DZ);
            }


            tanU0 = Math.Tan(U[i]);
            tanV0 = Math.Tan(V[i]);
            XB = X[i] + tanU0 * Z[i] - Ox[i + 1];
            YB = Y[i] + tanV0 * Z[i] - Oy[i + 1];
            if (aR[i + 1] == 0)
            {//半径R=∞の時は平面となる。
                Z[i + 1] = D[i];
            }
            else
            {//半径R≠∞の時
                A = 1 + tanU0 * tanU0 + tanV0 * tanV0;
                B = -2 * (D[i] + 1 / aR[i + 1] + tanU0 * XB + tanV0 * YB);
                C = D[i] * D[i] + 2 * D[i] / aR[i + 1] + XB * XB + YB * YB;

                if (aR[i + 1] > 0) Z[i + 1] = (-B - Math.Sqrt(B * B - 4 * A * C)) / (2 * A);
                if (aR[i + 1] < 0) Z[i + 1] = (-B + Math.Sqrt(B * B - 4 * A * C)) / (2 * A);
            }

            X[i + 1] = X[i] - tanU0 * (Z[i + 1] - Z[i]);
            Y[i + 1] = Y[i] - tanV0 * (Z[i + 1] - Z[i]);


            Hx = (-X[i + 1] + Ox[i + 1]) * aR[i + 1];//X方向法線ベクトル
            Hy = (-Y[i + 1] + Oy[i + 1]) * aR[i + 1];//Y方向法線ベクトル
            if (aR[i + 1] == 0)
            {//半径R=∞の時
                Hz = 1;//Z方向法線ベクトル
            }
            else
            {//半径R≠∞の時
                Hz = (-Z[i + 1] + D[i] + 1 / aR[i + 1]) * aR[i + 1];//Z方向法線ベクトル
            }
            L0z = 1 / Math.Sqrt(1 + tanU0 * tanU0 + tanV0 * tanV0);//Z方向入射ベクトル
            L0x = -tanU0 * L0z;//X方向入射ベクトル
            L0y = -tanV0 * L0z;//Y方向入射ベクトル

            Sta0 = Math.Acos(Math.Abs(Hx * L0x + Hy * L0y + Hz * L0z));//入射角度
            sinS0 = Math.Sin(Sta0);
            cosS0 = Math.Cos(Sta0);
            Sta1 = Sta0;//出射角度
            sinS1 = Math.Sin(Sta1);
            cosS1 = Math.Cos(Sta1);



            Ct = 2.0 * sinS0;

            Kh = cosS1;
            DHx = (Kh * Hx) - L0x;
            DHy = (Kh * Hy) - L0y;
            DHz = (Kh * Hz) - L0z;



            ADH = Math.Sqrt(DHx * DHx + DHy * DHy + DHz * DHz);//変化量の絶対値

            if (ADH == 0)
            {//変化量ゼロの場合
                L1x = L0x;
                L1y = L0y;
                L1z = L0z;
            }
            else
            {//屈折した場合
                L1x = L0x + Ct * DHx / ADH;
                L1y = L0y + Ct * DHy / ADH;
                L1z = L0z + Ct * DHz / ADH;
            }
            U[i + 1] = -Math.Atan(L1x / L1z);//X方向出射角度
            V[i + 1] = -Math.Atan(L1y / L1z);//Y方向出射角度


            D[i] = D0;
            U[i + 1] = U[i + 1] - 2 * P[i + 1];
            V[i + 1] = V[i + 1] - 2 * P2[i + 1];

            Z[i + 1] = 2 * D[i] - Z[i + 1];
            U[i + 1] = -U[i + 1];
            V[i + 1] = -V[i + 1];
        }







    }
}




