﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Illumination
{
    public partial class UserControl1 : UserControl
    {
        public MainWindow UC;
        public Boolean BEdit = false;


        public UserControl1()
        {
            InitializeComponent();
        }

        public void SetUC()
        {
            int N = Convert.ToInt32(UC.TextBox1.Text);
            dataGridView1.RowCount = N + 4;
            dataGridView1.Rows[0].Cells[0].Value = "i";
            dataGridView1.Rows[0].Cells[1].Value = "aR[i]";
            dataGridView1.Rows[0].Cells[2].Value = "Dr[i]";
            dataGridView1.Rows[0].Cells[3].Value = "Ox[i]";
            dataGridView1.Rows[0].Cells[4].Value = "Oy[i]";
            dataGridView1.Rows[0].Cells[5].Value = "Ｍ[i]";
            dataGridView1.Rows[0].Cells[6].Value = "Ｐ[i]";
            dataGridView1.Rows[0].Cells[7].Value = "Ｐ2[i]";
            dataGridView1.Rows[0].Cells[8].Value = "N[1,i]";
            dataGridView1.Rows[0].Cells[9].Value = "N[2,i]";
            dataGridView1.Rows[0].Cells[10].Value = "N[3,i]";

            dataGridView1.Rows[1].Cells[0].Value = "整数";
            dataGridView1.Rows[1].Cells[1].Value = "1/mm";
            dataGridView1.Rows[1].Cells[2].Value = "mm";
            dataGridView1.Rows[1].Cells[3].Value = "mm";
            dataGridView1.Rows[1].Cells[4].Value = "mm";
            dataGridView1.Rows[1].Cells[5].Value = "整数";
            dataGridView1.Rows[1].Cells[6].Value = "小数点";
            dataGridView1.Rows[1].Cells[7].Value = "小数点";
            dataGridView1.Rows[1].Cells[8].Value = "無次元";
            dataGridView1.Rows[1].Cells[9].Value = "無次元";
            dataGridView1.Rows[1].Cells[10].Value = "無次元";
            int i;

            for (i = 1; i <= N; i++) { dataGridView1.Rows[1 + i].Cells[0].Value = Convert.ToString(i); }
        }

        public void SetData()
        {
            dataGridView1.Rows[2].Cells[1].Value = "0.7071";
            dataGridView1.Rows[2].Cells[2].Value = "0.7071";
            dataGridView1.Rows[2].Cells[3].Value = "-10.5";
            dataGridView1.Rows[2].Cells[4].Value = "10.5";
            dataGridView1.Rows[2].Cells[5].Value = "-10.5";
            dataGridView1.Rows[2].Cells[6].Value = "10.5";
        }



        private void dataGridView1_KeyDown(object sender, KeyEventArgs e)
        {
            var k = e.KeyCode;
            if (k == Keys.F1)//コピー
            {
                var cc = dataGridView1.CurrentCellAddress;
                if (dataGridView1.Rows[cc.Y].Cells[cc.X].Value != null)
                {
                    System.Windows.Forms.Clipboard.SetDataObject(new DataObject(dataGridView1.Rows[cc.Y].Cells[cc.X].Value));
                }
            }

            if (k == Keys.F2)//ペースト
            {
                var cc = dataGridView1.CurrentCellAddress;
                var objData = System.Windows.Forms.Clipboard.GetDataObject();

                if (objData.GetDataPresent(DataFormats.StringFormat))
                {
                    String str = (String)objData.GetData(DataFormats.StringFormat);
                    if (str != "dataGridView1.Rows[cc.Y].Cells[cc.X].Value")
                    {
                        dataGridView1.Rows[cc.Y].Cells[cc.X].Value = str;
                    }
                }
            }

            if (k == Keys.F3)//クリア
            {
                var cc = dataGridView1.CurrentCellAddress;
                dataGridView1.Rows[cc.Y].Cells[cc.X].Value = "";
            }
        }

        private void dataGridView1_CellBeginEdit(object sender, DataGridViewCellCancelEventArgs e)
        {
            BEdit = true;
        }

        private void dataGridView1_CellEndEdit(object sender, DataGridViewCellEventArgs e)
        {
            BEdit = false;
            dataGridView1.Invalidate();

        }
    }
}
