﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Forms;


namespace Illumination
{
    /// <summary>
    /// Window2.xaml の相互作用ロジック
    /// </summary>
    public partial class Window2 : Window
    {
        Color[] c = new Color[18];
        int N;
        double[,] MT;

        public Window2()
        {
            InitializeComponent();
        }

        private void Button1_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        public void Draw1(DataGridView dataGridView1)
        {
            int i, j;

            N = Convert.ToInt32(dataGridView1.Rows[0].Cells[1].Value);
            MT = new double[N + 1, N + 1];

            for (i = 0; i <= N; i++)
            {
                for (j = 0; j <= N; j++)
                {
                    MT[j, i] = Convert.ToDouble(dataGridView1.Rows[6+j].Cells[i].Value);
                }
            }
            Draw();

        }


        public void Draw2(DataGridView dataGridView1)
        {
            int i, j;

            N = Convert.ToInt32(dataGridView1.Rows[0].Cells[1].Value);
            MT = new double[N + 1, N + 1];

            for (i = 0; i <= N; i++)
            {
                for (j = 0; j <= N; j++)
                {
                    MT[j, i] = Convert.ToDouble(dataGridView1.Rows[6 + j+N+3].Cells[i].Value);
                }
            }
            Draw();
        }

        public void Draw3(DataGridView dataGridView1)
        {
            int i, j;

            N = Convert.ToInt32(dataGridView1.Rows[0].Cells[1].Value);
            MT = new double[N + 1, N + 1];

            for (i = 0; i <= N; i++)
            {
                for (j = 0; j <= N; j++)
                {
                    MT[j, i] = Convert.ToDouble(dataGridView1.Rows[6 + j + (N + 3)*2].Cells[i].Value);
                }
            }
            Draw();
        }

         void Draw()
        {
            int i, j, k;
            double II;
            SetMyC();
            int P = 4;



            double[,] Z = new double[2 * N + 1, 2 * N + 1];
            for (i = 0; i <= N-1 ; i++)
            {
                for (j = 0; j <= N - 1; j++)
                {
                    Z[2 * i, 2 * j] = MT[i,j];
                }
            }
            for (i = 0; i <= N - 1; i++)
            {
                for (j = 0; j <= N - 2; j++)
                {
                    Z[2 * i, 2 * j + 1] = (Z[2 * i, 2 * j] + Z[2 * i, 2 * j + 2]) / 2;
                }
            }
            for (i = 0; i <= N - 2; i++)
            {
                for (j = 0; j < 2 * (N - 1); j++)
                {
                    Z[2 * i + 1, j] = (Z[2 * i, j] + Z[2 * i + 2, j]) / 2;
                }
            }

            Path[,] myPath = new Path[2 * N + 2, 2 * N + 2];
            RectangleGeometry[,] myGeometry = new RectangleGeometry[2 * N + 2, 2 * N + 2];


            double[,] Z2 = new double[2 * N + 1, 2 * N + 1];
            int ki, kj;
            for (i = 1; i <= 2*N-1; i++)
            {
                for (j = 1; j <=2* N-1; j++)
                {
                    for (ki = -1; ki <= 1; ki++)
                    {
                        for (kj = -1; kj <= 1; kj++)
                        {
                            Z2[i, j] = Z2[i, j] + Z[i + ki, j + kj];
                        }
                    }
                    Z2[i, j] = Z2[i, j] / 9;
                }
            }



            double IImax = 0;
            for (i = 0; i <= 2*N; i++)
            {
                for (j = 0; j <= 2*N; j++)
                {
                    if (Z2[i, j] > IImax)
                    { IImax = Z2[i, j]; }
                }
            }



            for (i = 0; i < 2 * N; i++)
            {
                for (j = 0; j < 2 * N; j++)
                {
                    myPath[i, j] = new Path();
                    myGeometry[i, j] = new RectangleGeometry();
                    II = Z2[i, j];
                    if (IImax > 0)
                    { k = (int)(II * 17 / IImax);}
                    else { k = 0; }
                    myPath[i, j].Fill = new SolidColorBrush(c[17 - k]);
                    myGeometry[i, j].Rect = new System.Windows.Rect(50 + P * i, 50 + P * j, P, P);
                    myPath[i, j].Data = myGeometry[i, j];
                    Grid1.Children.Add(myPath[i, j]);

                }
            }


        }

        public void SetMyC()
        {
            int i;
            for (i = 0; i < 3; i++)
            {
                c[i] = Color.FromArgb(255, Convert.ToByte(255 - 75 * i), 0, 0);
                c[i + 3] = Color.FromArgb(255, Convert.ToByte(150 - 40 * i), Convert.ToByte(150 - 40 * i), 0);
                c[i + 6] = Color.FromArgb(255, 0, Convert.ToByte(255 - 75 * i), 0);
                c[i + 9] = Color.FromArgb(255, 0, Convert.ToByte(150 - 40 * i), Convert.ToByte(150 - 40 * i));
                c[i + 12] = Color.FromArgb(255, 0, 0, Convert.ToByte(255 - 75 * i));
                c[i + 15] = Color.FromArgb(255, Convert.ToByte(150 - 40 * i), 0, Convert.ToByte(150 - 40 * i));
            }
        }
    }
}
